(* Code from Pascal column in Micro Cornucopia Issue #38 *)

DEFINITION MODULE Config;

(* This module provides the basic constants which define the graphics screen.
   Xsize is in pixels, Ysize is in rows, Unused is in Bytes (the interleaved
   formats have a few bytes left over in each interleaved array) and
   ScrSegment is the segment address of the screen memory.  Use the values
   for the type of your display adapter.  This definition module is the only
   one which needs to be different for the different adapters.*)

(* Depending on the compiler, you may need this EXPORT
   EXPORT QUALIFIED Xsize, Ysize, Interleave, Unused, ScrSegment; *)

CONST    (*     HGA           CGA               EGA   *)
   Xsize =      720;     (*   640               640   *)
   Ysize =      348;     (*   200               350   *)
   Interleave =   4;     (*     2                 1   *)
   Unused =     362;     (*   192                 0   *)
   ScrSegment = 0b000h;  (* 0b800h            0a000h  *)

END Config.

